fstests: _fail test by default when _scratch_mount fails
[xfstests-dev.git] / tests / generic / 068
1 #! /bin/bash
2 # FSQA Test No. 068
3 #
4 # Test case to reproduce xfs_freeze hang under filsystem load.
5 # The fail case for this test is a hang on an xfs_freeze.
6 #
7 #-----------------------------------------------------------------------
8 # Copyright (c) 2000-2005 Silicon Graphics, Inc.  All Rights Reserved.
9 #
10 # This program is free software; you can redistribute it and/or
11 # modify it under the terms of the GNU General Public License as
12 # published by the Free Software Foundation.
13 #
14 # This program is distributed in the hope that it would be useful,
15 # but WITHOUT ANY WARRANTY; without even the implied warranty of
16 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
17 # GNU General Public License for more details.
18 #
19 # You should have received a copy of the GNU General Public License
20 # along with this program; if not, write the Free Software Foundation,
21 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
22 #
23 #-----------------------------------------------------------------------
24 #
25
26 seq=`basename $0`
27 seqres=$RESULT_DIR/$seq
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=0        # success is the default!
33
34 ITERATIONS=10
35
36 _cleanup()
37 {
38     cd /
39
40     trap 0 1 2 3 15
41     exit $status
42 }
43
44 trap "_cleanup" 0 1 2 3 15
45
46 # get standard environment, filters and checks
47 . ./common/rc
48 . ./common/filter
49
50 # real QA test starts here
51 _supported_fs generic
52 _supported_os Linux
53
54 _require_scratch
55 _require_freeze
56
57 echo "*** init FS"
58
59 rm -f $seqres.full
60 _scratch_unmount >/dev/null 2>&1
61 echo "*** MKFS ***"                         >>$seqres.full
62 echo ""                                     >>$seqres.full
63 _scratch_mkfs                               >>$seqres.full 2>&1 \
64     || _fail "mkfs failed"
65 _scratch_mount
66
67 touch $tmp.running
68
69 # start fsstress loop in a background block
70 {
71     STRESS_DIR="$SCRATCH_MNT/fsstress_test_dir"
72     mkdir "$STRESS_DIR"
73
74     procs=2
75     nops=200
76     while [ -f "$tmp.running" ]
77       do
78       # We do both read & write IO - not only is this more realistic,
79       # but it also potentially tests atime updates
80       FSSTRESS_ARGS=`_scale_fsstress_args -d $STRESS_DIR -p $procs -n $nops $FSSTRESS_AVOID`
81       $FSSTRESS_PROG $FSSTRESS_ARGS > /dev/null 2>&1
82     done
83
84     rm -r $STRESS_DIR/*
85     rmdir $STRESS_DIR
86 } &
87
88 # start fstest -m loop in a background block; this gets us mmap coverage
89 {
90     FSTEST_DIR="$SCRATCH_MNT/fstest_test_dir"
91     mkdir "$FSTEST_DIR"
92
93     procs=2
94     while [ -f "$tmp.running" ]
95       do
96       src/fstest -m -p $FSTEST_DIR  -n $procs -f 4 > /dev/null 2>&1
97     done
98
99     rm -rf $FSTEST_DIR/*
100     rmdir $FSTEST_DIR
101 } &
102
103 i=0
104 let ITERATIONS=$ITERATIONS-1
105
106 echo | tee -a $seqres.full
107 while [ $i -le $ITERATIONS ]
108 do
109         echo "*** iteration: $i" | tee -a $seqres.full
110         echo "*** freezing \$SCRATCH_MNT" | tee -a $seqres.full
111         xfs_freeze -f "$SCRATCH_MNT" | tee -a $seqres.full
112         [ $? != 0 ] && echo xfs_freeze -f "$SCRATCH_MNT" failed | \
113             tee -a $seqres.full
114         sleep 2
115
116         echo "*** thawing  \$SCRATCH_MNT" | tee -a $seqres.full
117         xfs_freeze -u "$SCRATCH_MNT" | tee -a $seqres.full
118         [ $? != 0 ] && echo xfs_freeze -u "$SCRATCH_MNT" failed | \
119             tee -a $seqres.full
120         sleep 2
121
122         echo  | tee -a $seqres.full
123         let i=$i+1
124 done
125
126 # stop fsstress iterations
127 rm $tmp.running
128
129 # wait for fsstresses to finish
130 wait
131
132 exit 1